]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- no %{_includedir} macro, it could be redefined in spec
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
19                 gettextize --copy --force --no-changelog; \
20         else \
21                 gettextize --copy --force --no-changelog --intl; \
22         fi; \
23         if [ ! -f po/Makevars ]; then \
24                 cp -f po/Makevars{.template,}; \
25         fi; \
26 }
27
28 %__glib_gettextize      glib-gettextize --copy --force
29 %__gnome_doc_common     gnome-doc-common --copy
30 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
31 %__gtkdocize            gtkdocize --copy
32 %__intltoolize          intltoolize --copy --force
33 %__libtoolize           libtoolize --copy --force
34
35 #       The number of cvs changelog entries kept when building package.
36 %_buildchangelogtruncate 20
37
38 %dependencytracking     %{nil}
39
40 #       Relations between package names that cause dependency loops
41 #       with legacy packages that cannot be fixed. Relations are
42 #       specified as
43 #               p>q
44 #       where package p has a Requires: on something that package q Provides:
45 #
46 # XXX   Note: that there cannot be any whitespace within the string "p>q",
47 #       and that both p and q are package names (i.e. no version/release).
48 %_dependency_whiteout   %{nil}
49
50
51 #-----------------------------------------------------------------
52 #
53 # (re)definition of %{rpm*flags} with %filterout_* support
54 # BuildRequires:        awk
55 # BuildRequires:        rpmbuild(macros) >= 1.315
56 #
57 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
58 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
59 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
60 # %rpmldflags   = %optldflags - %filterout_ld
61 #
62 # Regular expressions are supported, but to avoid some character be treated
63 # as regular expression it must be escaped twice.
64
65 %filter_out                                             \
66         for (i = 1; i in I; i++) {      A=0;    \
67                 for (f in F) {                          \
68                         if (I[i] ~ "^" F[f] "$") A=1;   \
69                 };                                                      \
70                 if (!A) printf(I[i] FS);        \
71         }
72
73 %rpmcflags %(awk 'BEGIN {
74         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
75         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
76         %{filter_out}
77 }')
78
79 %rpmcxxflags %(awk 'BEGIN {
80         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
81         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
82         %{filter_out}
83 }')
84
85 %rpmldflags %(awk 'BEGIN {
86         split("%{?optldflags}",I);
87         split("%{?filterout_ld}",F)
88         %{filter_out}
89 }')
90
91 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
92 # but, don't use it, better use gcc as linker
93 %ld_rpmldflags %(awk 'BEGIN {
94         split("%{rpmldflags}",F);
95         for (f in F) {
96                 s = F[f];
97                 if (s ~ /^-Wl,/) {
98                         s = substr(s,5);
99                         gsub(/,/," ",s);
100                 };
101                 printf(s FS);
102         };
103 }')
104
105 #-----------------------------------------------------------------
106 %configure2_13 { \
107  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
108  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
109  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
110  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
111  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
112  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
113  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
114  %{?__cc:CC="%{__cc}" ; export CC ; } \
115  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
116  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
117         --host=%{_target_platform} \
118         --prefix=%{_prefix} \
119         --exec-prefix=%{_exec_prefix} \
120         --bindir=%{_bindir} \
121         --sbindir=%{_sbindir} \
122         --sysconfdir=%{_sysconfdir} \
123         --datadir=%{_datadir} \
124         --includedir=%{_includedir} \
125         --libdir=%{_libdir} \
126         --libexecdir=%{_libexecdir} \
127         --localstatedir=%{_localstatedir} \
128         --sharedstatedir=%{_sharedstatedir} \
129         --mandir=%{_mandir} \
130         --infodir=%{_infodir} \
131         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
132         %{dependencytracking} \
133 }
134
135 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
136 %__cmake        /usr/bin/cmake
137 %cmake { \
138 CC="%{__cc}" \
139 CXX="%{__cxx}" \
140 CFLAGS="%{rpmcflags}" \
141 CXXFLAGS="%{rpmcxxflags}" \
142 %{__cmake} \
143 }
144
145 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
146 %__scons        /usr/bin/scons
147 %scons { \
148 %{__scons} \
149         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
150         CFLAGS="${CFLAGS:-%rpmcflags}" \
151         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
152         FFLAGS="${FFLAGS:-%rpmcflags}" \
153         CPPFLAGS="${CPPFLAGS:-}" \
154         %{?__cc:CC="%{__cc}"} \
155         %{?__cxx:CXX="%{__cxx}"} \
156         libsuffix=%{_lib} \
157         prefix=%{_prefix} \
158 }
159
160 # waf. see waf.spec
161 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
162 %__waf  /usr/bin/waf
163 %waf { \
164 CC="%{__cc}" \
165 CXX="%{__cxx}" \
166 CPP="%{__cpp}" \
167 CFLAGS="%{rpmcflags}" \
168 CXXFLAGS="%{rpmcxxflags}" \
169 %{__waf} \
170 }
171
172 #----------------------------------------------------------------
173 %global configure_cache 0
174 %configure_cache_file   %{buildroot}.configure.cache
175
176 %configure {./configure \
177         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
178         CFLAGS="${CFLAGS:-%rpmcflags}" \
179         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
180         FFLAGS="${FFLAGS:-%rpmcflags}" \
181         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
182         CPPFLAGS="${CPPFLAGS:-}" \
183         %{?__cc:CC="%{__cc}"} \
184         %{?__cxx:CXX="%{__cxx}"} \
185         --host=%{_target_platform} \
186         --build=%{_target_platform} \
187         --prefix=%{_prefix} \
188         --exec-prefix=%{_exec_prefix} \
189         --bindir=%{_bindir} \
190         --sbindir=%{_sbindir} \
191         --sysconfdir=%{_sysconfdir} \
192         --datadir=%{_datadir} \
193         --includedir=%{_includedir} \
194         --libdir=%{_libdir} \
195         --libexecdir=%{_libexecdir} \
196         --localstatedir=%{_localstatedir} \
197         --sharedstatedir=%{_sharedstatedir} \
198         --mandir=%{_mandir} \
199         --infodir=%{_infodir} \
200         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
201         %{dependencytracking} \
202         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
203 }
204
205 # ------------------------------------------------------------------------
206 # Overloading of some basic macros
207 %prep \
208 %%prep\
209 export LC_ALL=C\
210 export LANG=C\
211 unset LINGUAS ||:\
212 unset LANGUAGE ||:\
213 unset LC_MESSAGES ||:\
214 unset DISPLAY ||:\
215 %{nil}
216
217 %build %%build\
218 export LC_ALL=C\
219 export LANG=C\
220 unset LINGUAS ||:\
221 unset LANGUAGE ||:\
222 unset LC_MESSAGES ||:\
223 unset DISPLAY ||:\
224 %{nil}
225
226 %install \
227 %if 0%{?_enable_debug_packages}\
228 %{?buildsubdir:%{debug_package}}\
229 %endif\
230 %%install\
231 export LC_ALL=C\
232 export LANG=C\
233 unset LINGUAS ||:\
234 unset LANGUAGE ||:\
235 unset LC_MESSAGES ||:\
236 unset DISPLAY ||:\
237 %{nil}
238
239 # Location of autoconf macros
240 %_aclocaldir    %(aclocal --print-ac-dir)
241
242 # Location of omf files
243 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
244
245 # Location of pkgconfig files
246 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
247
248 # Location of desktop files
249 %_desktopdir    /usr/share/applications
250 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
251
252 # Location of pixmaps for applnk/desktop files
253 %_pixmapsdir    /usr/share/pixmaps
254
255 # Location of themable icons for applnk/desktop files
256 %_iconsdir      /usr/share/icons
257
258 # Location of fonts directories
259 %_fontsdir      /usr/share/fonts
260
261 # Location of Gtk and associated libraries documentation
262 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
263
264 # Location of KDE documentation
265 %_kdedocdir     %{_defaultdocdir}/kde/HTML
266
267 # unsermake script
268 %__unsermake /usr/share/unsermake/unsermake
269
270 # Current date
271 %date           %(LC_ALL="C" date +"%a %b %d %Y")
272
273 # tmp directory
274 %tmpdir         %(echo "${TMPDIR:-/tmp}")
275
276 # Example files, programs, scripts...
277 %_examplesdir   /usr/src/examples
278
279 # Alternative kernel type/version
280 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
281
282 # The directory holding Linux kernel sources
283 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
284
285 # If non-empty "debug" macro defined, add "dbg" suffix to release number
286 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
287
288 # Requires name = version-release
289 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
290
291 %releq_kernel()         %((LC_ALL="C" rpm -qf --qf '%%{name} = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
292 %requires_releq_kernel(s:)      Requires%{-s:(%{-s*})}: %releq_kernel
293
294 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
295 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
296
297 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
298
299 # kernel version-release handling
300 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
301 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
302 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
303 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
304 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
305
306 # sgml macros
307 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
308 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
309 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
310 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
311 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
312 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
313 %docbook_sgmlcat_fix() { for l in \
314 '' \
315 '  -- default decl --' \
316 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
317 '  -- hacks for opensp --' \
318 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
319 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
320 '' \
321 ; do echo $l; done >> %1 \
322 }
323
324 # vim - "
325
326 # minimum file size needed for compressed documents.
327 # just smaller files than this get larger when compressed.
328 # some stats:
329 # - 0 byte file compressed was 25 bytes .gz
330 # - 39 byte file was compressed as 57
331 # - with test/test.spec@man 158 byte file was compressed also 158
332 %_min_compress_bytes    159
333
334 #-----------------------------------------------------------------
335 # find and gzip all files in %{_mandir} and %{infodir}
336 #
337 # Requires: xargs, find
338 #
339 #%no_install_post_compress_docs 1
340 %__spec_install_post_compress_docs { \
341 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
342         for i in /usr/share/man /usr/X11R6/man; do \
343                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
344                         echo "Compress man pages: $i"; \
345                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
346                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
347                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
348                 fi; \
349         done; \
350         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
351                 echo "Compress info pages: %{_infodir}"; \
352                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
353                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
354                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
355         fi; \
356 }; __spec_install_post_compress_docs } }
357
358 #-----------------------------------------------------------------
359 # Strip executable binaries and shared object files
360 #
361 # Requires: find, awk, strip, cut, xargs
362 #
363 #%no_install_post_strip 1
364 %__spec_install_post_strip {%{!?debug: \
365 %{!?no_install_post_strip:__spec_install_post_strip() { \
366 if [ -d "$RPM_BUILD_ROOT" ]; then \
367         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
368                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
369                 printf "Stripping %d kernel modules..." $(echo "$modulelist" | wc -l); \
370                 echo "$modulelist" | xargs -l512 chmod u+w; \
371                 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
372                 echo "DONE"; \
373         fi; \
374         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
375         # vim - " \
376         if [ -z "$filelist" ]; then \
377                 return; \
378         fi; \
379         filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
380         elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
381         elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
382         archiveslist=`echo "$filetypes" | awk -F '/current ar archive/ {print $1}'`; \
383         if [ -n "$elfexelist" ]; then \
384                 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
385                 chmod u+w $elfexelist; \
386                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
387                 echo "DONE"; \
388         fi; \
389         if [ -n "$elfsharedlist" ]; then \
390                 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
391                 chmod u+w $elfsharedlist; \
392                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
393                 echo "DONE"; \
394         fi; \
395         if [ -n "$archiveslist" ]; then \
396                 printf "Stripping %d ar archives..." $(echo "$elfsharedlist" | wc -l); \
397                 chmod u+w $archiveslist; \
398                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
399                 echo "DONE"; \
400         fi; \
401 fi; }; __spec_install_post_strip } } }
402
403 #-----------------------------------------------------------------
404 # remove all RPATH from executable binaries and shared object files
405 #
406 # Requires: find, awk, cut, xargs, chrpath, uname
407 #
408 #%no_install_post_chrpath       1
409 %__spec_install_post_chrpath {%{!?debug: \
410 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
411 if [ -d "$RPM_BUILD_ROOT" ]; then \
412         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*"  %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
413         if [ -n "$files" ]; then \
414                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
415         fi
416         #"
417         if [ -n "$objs" ]; then \
418                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
419                 echo "$objs" | \
420                 while read file; do \
421                         rpath= ; \
422                         chmod u+w "$file"; \
423                         for dir in `chrpath -l "$file" | \
424                                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
425                                         case $dir in \
426                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
427                                                 echo "remove-rpath: $dir in $file"; \
428                                                 ;; \
429                                         * ) \
430                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
431                                                 else rpath="$rpath:$dir" ; fi ; \
432                                                 ;; \
433                                         esac ; \
434                         done ; \
435                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
436                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
437                 done; \
438         fi; \
439 fi; }; __spec_install_post_chrpath } } }
440
441 #-----------------------------------------------------------------
442 # Find and gzip all kernel modules
443 #
444 # Requires: find
445 #
446 #%no_install_post_compress_modules      1
447 %__spec_install_post_compress_modules { \
448 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
449         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
450                 echo "Compress kernel modules"; \
451                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
452                 echo "$q" | xargs -r %{__gzip} -9nf; \
453                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
454                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
455                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
456         fi; \
457 }; __spec_install_post_compress_modules } }
458
459 # Remove common Perl files we don't package
460 %__spec_install_post_perl_clean {\
461 %{!?no_install_post_perl_clean: \
462 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
463 } }
464
465 #-----------------------------------------------------------------
466 # Update GConf2 schemas
467 #
468 # Requires: GConf2
469 #
470 %gconf_schema_install() \
471         umask 022; \
472         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
473         %{nil}
474
475 %gconf_schema_uninstall() \
476 if [ $1 = 0 ]; then \
477         umask 022; \
478         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
479 fi \
480 %{nil}
481
482 #-----------------------------------------------------------------
483 # Update desktop MIME database
484 # requires: desktop-file-utils
485 #
486 %update_desktop_database_post() {{ \
487         umask 022; \
488         /usr/bin/update-desktop-database -q; \
489 }} \
490 %{nil}
491
492 %update_desktop_database_postun() {{ \
493 if [ $1 = 0 ]; then \
494         umask 022; \
495         /usr/bin/update-desktop-database -q; \
496 fi \
497 }} \
498 %{nil}
499
500 #-----------------------------------------------------------------
501 # Update shared MIME info database
502 # requires: shared-mime-info
503 #
504 %update_mime_database() {{ \
505         umask 022; \
506         /usr/bin/update-mime-database %{_datadir}/mime; \
507 }} \
508 %{nil}
509
510 #-----------------------------------------------------------------
511 # Update icon cache
512 # requires: gtk+
513 #
514 %update_icon_cache() {{ \
515         umask 022; \
516         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
517 }} \
518 %{nil}
519
520 #-----------------------------------------------------------------
521 # Update scrollkeeper database
522 # requires: scrollkeeper
523 #
524 %scrollkeeper_update_post() \
525         /usr/bin/scrollkeeper-update -q; \
526         %{nil}
527
528 %scrollkeeper_update_postun() \
529 if [ $1 = 0 ]; then \
530         /usr/bin/scrollkeeper-update -q; \
531 fi \
532 %{nil}
533
534 #-----------------------------------------------------------------
535 # post %install sequence:
536 # - autodeps exceptions
537 # - compress all man and info pages,
538 # - strip all ELF executables and ELF shared objects if not %debug.
539 # - compress kernel modules if any
540
541 ###################################################################
542 # Requires/Provides automation
543 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
544 #
545 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
546 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
547 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
548 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
549 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
550 #%_noautocompressdoc    %{nil}
551 #
552 %_missing_doc_files_terminate_build     1%{nil}
553 %_unpackaged_files_terminate_build      %{nil}
554 # (X)emacs support
555 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
556 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
557 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
558
559 %__php_provides %{nil}
560 %__php_requires %{nil}
561 %__perl_provides %{nil}
562 %__perl_requires %{nil}
563 %__mono_provides %{nil}
564 %__mono_requires %{nil}
565
566 # Perl specific macro definitions.
567 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
568 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
569 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
570 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
571 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
572 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
573
574 # Ruby
575 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
576 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
577 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
578 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
579 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
580 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
581 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
582 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
583
584 %php_pear_dir           /usr/share/pear
585 %php_extensiondir       %(php-config --extension-dir 2>/dev/null || echo ERROR)
586 %php_sysconfdir         %(php-config --sysconfdir 2>/dev/null || echo ERROR)
587
588 # directory where php includes are installed on system.
589 %__php_includedir               /usr/include/php
590 # extract php/zend api versions
591 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
592 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
593 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
594 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
595 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
596 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
597 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
598
599 # helper macro
600 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
601
602 # macros for public use
603 # for php extensions (php-pecl)
604 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
605 %{__php_api_requires zend_module_api} \
606 %{__php_api_requires -v %php_major_version debug php_debug} \
607 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
608
609 # for zend extensions
610 %requires_zend_extension %{__php_api_requires zend_module_api} \
611 %{__php_api_requires zend_extension_api} \
612 %{__php_api_requires -v %php_major_version debug php_debug} \
613 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
614
615 # for php pdo modules (php-pecl-PDO_*)
616 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
617
618 # for using PHP post scripts. for PHP >= 5.0
619 %php_webserver_restart \
620 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
621 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
622 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
623         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
624         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
625                 %service -q php-fcgi restart \
626         fi \
627 fi \
628 %{nil}
629
630 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
631 %php4_webserver_restart \
632 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
633 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
634 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
635         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
636         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
637                 %service -q php-fcgi restart \
638         fi \
639 fi \
640 %{nil}
641
642
643 # X.org helper macros
644 %__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
645 #
646 %xorg_xserver_ansic_abi         %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h)
647 %xorg_xserver_extension_abi     %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h)
648 %xorg_xserver_font_abi          %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h)
649 %xorg_xserver_videodrv_abi      %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h)
650 %xorg_xserver_xinput_abi                %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h)
651
652 %requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
653 %{__xorg_abi_requires extension xorg_xserver_extension_abi}
654 %requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
655 %{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
656 %requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
657 %{__xorg_abi_requires font xorg_xserver_font_abi}
658 %requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
659 %{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
660
661 # Python specific macro definitions.
662 # python main version
663 %py_ver                 %(python -c "import sys; print sys.version[:3]")
664
665 # directories
666 %py_prefix              %(python -c "import sys; print sys.prefix")
667 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
668 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
669 %py_incdir              /usr/include/python%{py_ver}
670 %py_sitedir             %{py_libdir}/site-packages
671 %py_sitescriptdir %{py_scriptdir}/site-packages
672 %py_dyndir              %{py_libdir}/lib-dynload
673
674 # pure python modules compilation
675 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
676
677 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
678
679 # Software written in Python language require Python with main version
680 %pyrequires_eq() Requires:      %1
681
682 # Hardlink binary identical .pyc and .pyo files
683 # (idea by glen <at> pld-linux <dot> org)
684 %__spec_install_post_py_hardlink {\
685 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
686 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
687         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
688         if cmp -s "$a" "$b"; then \
689                 ln -f "$a" "$b"; \
690         fi; \
691 done \
692 }; __spec_install_post_py_hardlink } }
693
694 # remove python sources, so that check-files won't complain
695 # (idea by glen <at> pld-linux <dot> org)
696 %py_postclean() \
697 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
698  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
699 done \
700 %{nil}
701
702 # depmod macro
703 %depmod() { \
704 umask 022; \
705 if [ -e /boot/System.map-%1 ]; then \
706         /sbin/depmod -a -F /boot/System.map-%1 %1; \
707 else \
708         if [ -e /boot/System.map ]; then \
709                 /sbin/depmod -a -F /boot/System.map %1; \
710         else \
711                 /sbin/depmod -a %1; \
712         fi \
713 fi; \
714 }
715
716 # XMMS specific macros
717 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
718 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
719 %xmms_version                   %(xmms-config --version 2>/dev/null)
720 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
721 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
722 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
723 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
724 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
725 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
726 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
727
728 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
729
730 # user/group checking macros
731 #
732 # Usage:
733 #       %userremove myuser
734 #
735 %userremove     /usr/lib/rpm/user_group.sh user del
736 %groupremove    /usr/lib/rpm/user_group.sh group del
737 #
738 # Usage:
739 #       if %usertestrm myuser; then
740 #               /usr/sbin/userdel -r myuser
741 # Note:
742 #       use these macros only if you need to call userdel/groupdel with
743 #       a non-standard option or take an extra action; otherwise use the
744 #       %userremove/%groupremove macros
745 #
746 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
747 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
748 # user group membership management macros
749 #
750 # Usage:
751 #       %addusertogroup myuser agroup
752 #
753 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
754
755 # banner support (useful in {pre,post}{,un} and triggers)
756 #
757 # Usage:
758 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
759 # the banner text, the banner text
760 # the banner text, and following line
761 #EOF
762 # You can use any form of here-document, <<'EOF' <<-EOT will do.
763 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
764 #
765 # -a   - append to the banner
766 # -e   - send to stderr instead of stdout
767 # -n   - no show banner (overrides -t)
768 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
769 %banner(aent:)  \
770 RPM_SCRIPTVERBOSITY=5 \
771 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
772 if [ -x /usr/bin/banner.sh ]; then \
773         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
774 else \
775         CMD="cat%{-e: >&2}" \
776 fi \
777 eval $CMD %2%{?3: %3} \
778 %nil
779
780 # useradd/groupadd macros
781 # Author: Elan Ruusamäe <glen@pld-linux.org>
782 #
783 # Usage:
784 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
785 #   [-g initial_group] [-G group[,...]] login
786 #
787 #  -u uid. REQUIRED
788 #  -g gid/group. REQUIRED
789 #  -s defaults to /bin/false
790 #  -d defaults to /usr/share/empty
791 #  -c No default
792 #  -r is accepted but ignored (it's always set)
793 #  -k skeleton dir. defaults to /usr/share/empty
794 # rpm specific flags
795 #  -P package name. defaults to %{name}
796 #
797 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
798 %{!-u:%{error:useradd: Required argument -u missing}} \
799 %{!-g:%{error:useradd: Required argument -g missing}} \
800 %{!?1:%{error:useradd: Required parameter login missing}} \
801 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
802         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
803                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
804                 exit 1 \
805         fi \
806 else \
807         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
808         /usr/sbin/useradd \\\
809                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
810                 -u %{-u*} \\\
811                 -r \\\
812                 -d %{-d*}%{!-d:/usr/share/empty} \\\
813                 -s %{-s*}%{!-s:/bin/false} \\\
814                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
815                 -g %{-g*} \\\
816                 %{-M} \\\
817                 %{-G:-G %{-G*}} \\\
818                 %{expand:%{%{#}}} 1>&2 || exit $? \
819         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
820 fi;
821
822 # Usage:
823 #   %groupadd [-P package] [-g gid] group
824 #
825 # -g gid. REQUIRED
826 #
827 # Sample:
828 #   %groupadd -P %{name}-base -g %{gid} %{name}
829
830 %groupadd(g:P:rfo)      \
831 %{!-g:%{error:groupadd: Required argument -g missing}} \
832 %{!?1:%{error:groupadd: Required parameter group missing}} \
833 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
834         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
835                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
836                 exit 1 \
837         fi \
838 else \
839         echo "Adding group %{1} GID=%{-g*}." \
840         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
841         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
842 fi;
843
844 # apache_config_{install/uninstall} macros *DEPRECATED*
845 # Author: Elan Ruusamäe <glen@pld-linux.org>
846 #
847 # You should use webapp macros instead. these are here until single piece of
848 # them is gone from specs ;)
849 #
850 # The config is installed/removed inside trigger, this means that you can any
851 # time install apache1 or apache package and the configuration file is updated.
852 # if you don't need the config for various reason for specific apache, just
853 # remove the symlink from apache config directory. the trigger will not put the
854 # config again to that version of apache. In other words the config is linked
855 # to apache config directory on first install of PACKAGE or apache.
856 #
857 # should be called in trigger body:
858 #  %triggerin -- apache1 >= 1.3.33-2
859 #  %apache_config_install -v 1
860 #
861 # Add package's apache config to apache config.
862 #
863 # Usage:
864 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
865 #
866 #  -v REQUIRED: specify apache version. can be 1 or 2.
867 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
868 #  -n OPTIONAL: specify config "slot". defaults to 99
869 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
870 #
871 # Internal macros. don't use ;).
872 # expands apache config dir by apache version at build time.
873 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
874 # expands apache service name by apache version at build time.
875 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
876
877 %apache_config_install(fv:c:n:) \
878 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
879 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
880 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
881         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
882 fi\
883 # reload apache if the config symlink is there\
884 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
885         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
886         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
887                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
888         fi\
889 fi\
890 %{nil}
891
892 # Remove package's apache config from apache config.
893 #
894 # Usage:
895 #   %apache_config_uninstall -v {1|2} -n 99
896 #
897 #  -v REQUIRED: specify apache version. can be 1 or 2.
898 #  -n OPTIONAL: specify config "slot". defaults to 99
899 %apache_config_uninstall(v:n:) \
900 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
901 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
902 # remove link if either of the packages are gone \
903 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
904         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
905                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
906                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
907                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
908                 fi \
909         fi \
910 fi \
911 %{nil}
912
913 # webapp macros
914 # Author: Elan Ruusamäe <glen@pld-linux.org>
915 #
916 # The config is installed/removed inside trigger, this means that you can any
917 # time install apache1/apache/lighttpd package and the configuration file is
918 # updated. if you don't need the config for various reason for specific
919 # webserver, just remove the symlink from config directory using webapp
920 # program. the trigger will not recreate the symlink on upgrades. In other
921 # words the config is linked to webserver config directory on first install of
922 # PACKAGE or WEBSERVER.
923 #
924 # Add package's webserver config to webserver webapps dir.
925 # Usage:
926 #   %webapp_register WEBSERVER WEBAPP
927 #
928 %webapp_register() \
929 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
930 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
931         /usr/sbin/webapp register %1 %2\
932 fi\
933 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
934 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
935         %{expand:%service -q %%1 reload}\
936 fi\
937 %{nil}
938
939 # Remove package's config from webserver webapps dir.
940 # Usage:
941 #   %webapp_register [-f] WEBSERVER WEBAPP
942 %webapp_unregister(f) \
943 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
944 # remove link if either of the packages are gone \
945 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
946         /usr/sbin/webapp unregister %1 %2\
947         %{expand:%service -q %%1 reload}\
948 fi \
949 %{nil}
950
951 # see browser-plugins.spec / template-browser-plugin.spec
952 # Author: Elan Ruusamäe <glen@pld-linux.org>
953 %nsplugin_install(d:f) { \
954 # create link if it's first install of either of the packages \
955 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
956 ( \
957 %( \
958         for file in %{*}; do \
959                 echo echo Installing $file to %{-d*}; \
960                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
961         done ) \
962 ) | ( %banner -t 5 -e %{name}-in ); fi; \
963 }
964
965 %nsplugin_uninstall(d:) { \
966 # remove link if either of the packages are gone \
967 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
968 ( \
969 %( \
970         for file in %{*}; do \
971                 echo echo Removing $file from %{-d*}; \
972                 echo "rm -f %{-d*}/$file;"; \
973         done ) \
974 ) | ( %banner -t 5 -e %{name}-un ); fi; \
975 }
976
977 # service macro.
978 # Author: Elan Ruusamäe <glen@pld-linux.org>
979 #
980 # calls usual service restart on package %post, but skips the restart if
981 # administrator has disabled automatic service restarts in either global
982 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
983 #
984 # Usage:
985 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
986 #
987 #  -q be silent when service isn't started (for scriplets restaring other package's services)
988 #
989 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
990
991
992 # Java macros. based on jpackage macros.java
993 #
994 # Root directory where all Java VMs/SDK/JREs are installed.
995 %_jvmdir                %{_libdir}/jvm
996
997 # Root directory where all Java VMs/SDK/JREs expose their jars
998 %_jvmjardir             %{_libdir}/jvm-exports
999
1000 # Root directory for all Java VM/SDK/JRE's private things.
1001 %_jvmprivdir    %{_libdir}/jvm-private
1002
1003 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1004 %_jvmlibdir             %{_libdir}/jvm
1005
1006 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
1007 %_jvmdatadir    %{_datadir}/jvm
1008
1009 # Root directory for all configurations parts of Java VM/SDK/JRE's
1010 %_jvmsysconfdir %{_sysconfdir}/jvm
1011
1012 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1013 %_jvmcommonlibdir       %{_libdir}/jvm-common
1014
1015 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1016 %_jvmcommondatadir      %{_datadir}/jvm-common
1017
1018 # Root directory for all common configurations parts of Java VM/SDK/JRE's
1019 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
1020
1021 # Directory where arch-specific (JNI) version-independent jars are installed.
1022 %_jnidir                %{_libdir}/java
1023
1024
1025 %java_home              %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
1026
1027 %ant                    JAVA_HOME=%{java_home} ant
1028 %jar                    %{java_home}/bin/jar
1029 %java                   %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
1030 %javac                  %{java_home}/bin/javac
1031 %javadoc                %{java_home}/bin/javadoc
1032
1033 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1034
1035 %jpackage_script() \
1036 install -d $RPM_BUILD_ROOT%{_bindir}\
1037 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1038 #!/bin/sh\
1039 #\
1040 # %{name} script\
1041 # JPackage Project <http://www.jpackage.org/>\
1042 \
1043 # Source functions library\
1044 . %{_javadir}-utils/java-functions\
1045 \
1046 # Source system prefs\
1047 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1048     . %{_sysconfdir}/java/%{name}.conf\
1049 fi\
1050 \
1051 # Source user prefs\
1052 if [ -f $HOME/.%{name}rc ]; then\
1053     . $HOME/.%{name}rc\
1054 fi\
1055 \
1056 # Configuration\
1057 MAIN_CLASS=%1\
1058 BASE_FLAGS=%2\
1059 BASE_OPTIONS=%3\
1060 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1061 \
1062 # Set parameters\
1063 set_jvm\
1064 set_classpath $BASE_JARS\
1065 set_flags $BASE_FLAGS\
1066 set_options $BASE_OPTIONS\
1067 \
1068 # Let's start\
1069 run "$@"\
1070 EOF
1071
1072 # PEAR install macros
1073 # Author: Elan Ruusamäe <glen@pld-linux.org>
1074 #
1075 # Usage:
1076 #       %%pear_package_setup [-a #] [-n FMT]
1077 #
1078 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1079 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1080 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1081 #
1082 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1083 # destination hierarchy. you should copy the tree to buildroot after
1084 # patching/reorganizing with %%pear_package_install.
1085 #
1086 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1087 # line endings.
1088 #
1089 # the pear install process output is recorded to install.log, you should put it
1090 # to %%doc for later debug or just for information.
1091 #
1092 # additionally additional-packages.txt is produced if it was detected that the
1093 # package has optional dependencies. the file format is suitable of displaying
1094 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1095 # automatically added for this file.
1096
1097
1098 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1099 %__pear_install_log \
1100 tee install.log \
1101 # make post message of optional packages \
1102 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1103 if [ -s optional-packages.txt ]; then \
1104         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1105 else \
1106         rm -f optional-packages.txt \
1107 fi \
1108 %{nil}
1109
1110 # command invoking pear cli
1111 %__pear /usr/bin/pear
1112
1113 %pear_install(a:n:zD) \
1114 %__pear \\\
1115         -c pearrc \\\
1116         -d doc_dir=/docs \\\
1117         -d php_dir=%{php_pear_dir} \\\
1118         -d bin_dir=%{_bindir} \\\
1119         -d data_dir=%{php_pear_dir}/data \\\
1120         -d test_dir=%{php_pear_dir}/tests \\\
1121         install \\\
1122         --packagingroot=%{builddir} \\\
1123         --offline \\\
1124         --nodeps \\\
1125         %{-f:--force} \\\
1126         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1127 %{nil}
1128
1129 # The main macro.
1130 # using this macro will append optional-packages.txt to the nocompressdoc list
1131 # as it's displayed to user after package install. and adding additional gzip
1132 # dep is just waste ;)
1133 %pear_package_setup(a:n:zD) \
1134 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1135 %define builddir %{_builddir}/%{srcdir} \
1136 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1137 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1138 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1139 %pear_install \
1140 %{-z:cd ..} \
1141 cat %{-z:$_N/}.install.log | %__pear_install_log \
1142 \
1143 # undos sources \
1144 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1145 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1146 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1147 %{nil}
1148
1149 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1150 # Author: Elan Ruusamäe <glen@pld-linux.org>
1151 %pear_package_install() \
1152 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1153 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1154 # help the developer out a little: \
1155 if [ -f _noautoreq ]; then \
1156         echo "AutoReqdep detected:" \
1157         echo "_noautoreq $(cat _noautoreq)" \
1158 fi \
1159 %{nil}
1160
1161
1162 # Register OpenLDAP schema.
1163 # Author: Elan Ruusamäe <glen@pld-linux.org>
1164 #
1165 # Usage:
1166 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1167 #
1168 #  -d specify dependant schemas, separated by comma
1169 #
1170 %openldap_schema_register(d:) \
1171 for schema in %*; do \
1172         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1173                 %{__sed} -i -e " \
1174                         /^include.*local.schema/{ \
1175                                 iinclude\\t     $schema\
1176                         } \
1177                 " /etc/openldap/slapd.conf \
1178         fi \
1179 done \
1180 # enable dependant schemas \
1181 if [ "%{-d*}" ]; then \
1182         %{__sed} -i -e ' \
1183         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1184                 s/^#// \
1185         }' /etc/openldap/slapd.conf \
1186 fi \
1187 %{nil}
1188
1189 # Unregister OpenLDAP schema.
1190 # Author: Elan Ruusamäe <glen@pld-linux.org>
1191 #
1192 # Usage:
1193 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1194 #
1195 %openldap_schema_unregister() \
1196 for schema in %*; do \
1197         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1198                 %{__sed} -i -e " \
1199                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1200                 # for symmetry it would be nice if we disable enabled schemas in post, \
1201                 # but we really can not do that, it would break something else. \
1202                 " /etc/openldap/slapd.conf \
1203         fi \
1204 done \
1205 %{nil}
1206
1207 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1208
1209
1210 # Build modules for kernels 2.6
1211 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1212 #
1213 # Usage:
1214 #       %build_kernel_modules -m <modules> -C <directory>
1215 #
1216 #  remember that proper Makefile is still required
1217 # Options:
1218 #  -m <modules> (required) -- comma-separated list of modules to save,
1219 #               without .ko extension, may be placed in subdirectory
1220 #  -C <directory> -- change to <directory> before doing anything
1221 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1222 #  -c -- do not execute make clean
1223 #  <additional arguments> -- all additional arguments will be passed to
1224 #               make modules
1225 #
1226 # Additional patching supported via here document. Try:
1227 #       %build_kernel_modules -m module <<'EOF'
1228 #       your patch script here
1229 #       EOF
1230 # Don't use it unless patching depends on config options.
1231
1232 # Developer note: don't touch it unless you know how to handle '\'.
1233 # - \ in script expands to nothing
1234 # - \\\ in script expands to \
1235 # - \\\ inside definition expands to nothing
1236 # - \\\\\\\ inside definition expands to \
1237 # - in last line \ has to touch arguments so arguments passing
1238 #   in new lines (using \) will be supported
1239
1240 %build_kernel_modules(p:P:m:C:c)                                                                        \
1241 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1242                                                                                                                                         \
1243 %define Opts                                                                                                            \\\\\\\
1244 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1245         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1246         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1247         %else                                                                                                                   \\\
1248         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1249         %endif                                                                                                                  \\\
1250 %else                                                                                                                           \\\
1251         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1252 %endif                                                                                                                          \
1253 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1254                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1255                                                                                                                                         \
1256 %{?-C:cd %{-C*}}                                                                                                        \
1257 compile() {                                                                                                                     \
1258         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1259         set -e -x                                                                                                               \
1260                                                                                                                                         \
1261 for cfg in %{?with_dist_kernel:dist}%{!?with_dist_kernel:nondist}; do \
1262         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1263                                                                                                                                         \
1264         rm -rf o                                                                                                                \
1265         install -d o/include/linux                                                                              \
1266         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1267         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1268         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1269 %ifarch ppc ppc64                                                                                                       \
1270         install -d o/include/asm                                                                                \
1271         [ ! -d %{_kernelsrcdir}/include/asm-%{_target_base_arch} ] || ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch}/* o/include/asm \
1272         [ ! -d %{_kernelsrcdir}/include/asm-powerpc ] || ln -snf %{_kernelsrcdir}/include/asm-powerpc/* o/include/asm   \
1273 %else                                                                                                                           \
1274         ln -sf %{_kernelsrcdir}/include/asm-%{_target_base_arch} o/include/asm \
1275 %endif                                                                                                                          \
1276                                                                                                                                         \
1277         set +x                                                                                                                  \
1278         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1279         set -x                                                                                                                  \
1280                                                                                                                                         \
1281         %if %{with dist_kernel}                                                                                 \
1282                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1283                         %{-p*} %{-P*}                                                                                   \\\
1284                         %{MakeOpts}                                                                                             \
1285         %else                                                                                                                   \
1286                 install -d o/include/config                                                                     \
1287                 touch o/include/config/MARKER                                                           \
1288                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1289         %endif                                                                                                                  \
1290                                                                                                                                         \
1291         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1292                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1293                 M=$PWD %{MakeOpts}}                                                                                     \
1294         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1295                 ${1+"$@"}                                                                                                       \\\
1296                 M=$PWD %{MakeOpts}                                                                                      \
1297                                                                                                                                         \
1298         for MODULE in {%{-m*},}; do                                                                             \
1299                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1300         done                                                                                                                    \
1301 done                                                                                                                            \
1302 %{?-C:cd -}                                                                                                                     \
1303 }                                                                                                                                       \
1304 compile %{*}\
1305 %{nil}
1306
1307
1308 # Install kernel modules built by %build_kernel_modules
1309 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1310 #
1311 # Usage:
1312 #       %install_kernel_modules -m <modules> -d <directory>
1313 #
1314 # Options:
1315 #  -m <modules> (required) -- comma-separated list of modules to install,
1316 #               without .ko extension, may be placed in subdirectory
1317 #  -d <directory> (required) -- in what subdirectory modules should be
1318 #               installed (eg. misc, kernel/drivers/net)
1319 #  -s <suffix> -- suffix to use when installing modules, useful when module
1320 #               with same name exists in kernel already
1321 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1322 #               for definig aliases, only useful with -s
1323
1324 %install_kernel_modules(m:d:s:n:)                                                                       \
1325 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1326 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1327 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1328                                                                                                                                         \
1329 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1330 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1331                                                                                                                                         \
1332 install -d %{KernelD}/%{-d*}                                                                    \
1333 %{?-s:install -d %{ModprobeD}}                                                          \
1334                                                                                                                                         \
1335 for MODULE in {%{-m*},}; do                                                                                     \
1336         [ -n "${MODULE}" ] || continue                                                                  \
1337         MNAME=${MODULE##*/}                                                                                             \
1338         %if %{without dist_kernel}                                                                              \
1339                 install ${MODULE}-nondist.ko                                                            \\\
1340                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1341                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1342                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1343         %else                                                                                                                   \
1344                 install ${MODULE}-dist.ko                                                                               \\\
1345                         %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                              \
1346                 %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                     \\\
1347                         >> %{ModprobeD}/%{-n*}.conf}                                                    \
1348         %endif                                                                                                                  \
1349 done                                                                                                                            \
1350 %{nil}
1351
1352 # patchset macros
1353 # Author: Elan Ruusamäe <glen@pld-linux.org>
1354 #
1355 # Usage:
1356 #   %patchset_source -f <seq(1) format> <start> [<end>]
1357 #   %patchset_patch <start> [<end>]
1358 #
1359 # If <end> is omited, it is assumed to be <start>.
1360 #
1361 # For example in preamble:
1362 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1363 # and in %prep:
1364 #  %patchset_patch 33 44
1365
1366 # generate SourceX urls from range START STOP
1367 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1368 # The sources start from 10000
1369 %patchset_source(f:b:) %(
1370         base=%{-b*}%{!-b*:10000};
1371         start=$(expr $base + %1);
1372         end=$(expr $base + %{?2}%{!?2:%{1}});
1373         # we need to call seq twice as it doesn't allow two formats
1374         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1375         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1376         paste %{tmpdir}/__ps{1,2};
1377         rm -f %{tmpdir}/__ps{1,2};
1378 ) \
1379 %{nil}
1380
1381 # apply sources from %patchset_source
1382 # -p specify -pX for %patch line
1383 # -b base offset: defaults to 10000
1384 %patchset_patch(f:p:b:) %(
1385         base=%{-b*}%{!-b*:10000};
1386         start=$(expr $base + %1);
1387         end=$(expr $base + %{?2}%{!?2:%{1}});
1388         echo ": patchset_patch %1%{?2: to %2}";
1389         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1390 ) \
1391 %{nil}
1392
1393 # browser plugins v2
1394 # Author: Elan Ruusamäe <glen@pld-linux.org>
1395 #
1396 # Usage:
1397 #       %browser_plugins_add_browser <name> -p <plugindir>
1398 #
1399 #  <name> (required) -- name of the browser. usually %{name}.
1400 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1401 #  -b -- default blacklists
1402 #  -a <arch> override arch
1403 #
1404 # Example:
1405 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1406
1407 %_browserpluginsconfdir         /etc/browser-plugins
1408 %_browserpluginsdir                     %{_libdir}/browser-plugins
1409 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1410
1411 %browser_plugins_add_browser(p:b:a:) \
1412         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1413         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1414         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1415         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1416         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1417         %{-b:cat >> $blacklist_file %{-b*}} \
1418 %{nil}
1419
1420 # vim:ts=4 sw=4 noet syn=spec
This page took 0.131234 seconds and 4 git commands to generate.